unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JPEG, ExtCtrls;

type
  TForm2 = class(TForm)
    Image1: TImage;
    procedure FormCanResize(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    Scale: Double;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}
const pathImage    = 'D:\Image.jpg';
var OnLoad: boolean = true;

procedure TForm2.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
var
  ScaleForm: Double;
begin

  if OnLoad then
  begin
    if Assigned(Image1.Picture) then
    begin
      NewWidth := Image1.Picture.Width;
      NewHeight := Image1.Picture.Height;
    end;
    OnLoad := false;
    Exit;
  end;

  ScaleForm := NewWidth / NewHeight;
  if ScaleForm > Scale then
  begin
    NewHeight := Trunc(NewWidth / Scale);
  end
  else
  begin
    NewWidth := Trunc(Scale * NewHeight);
  end;


end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  if (FileExists(pathImage)) then
    Image1.Picture.LoadFromFile(pathImage);

  Scale := Image1.Picture.Width / Image1.Picture.Height;
end;

end.
